#!/usr/bin/env python
# -*- coding: iso-8859-15 -*-
#-------------------------------python-----------------------korrot.py--#
#                                                                       #
#                 Olimpiadi dell'informatica: Korrot                    #
#                                                                       #
#--Daniele Zambelli----------licenza GPL-------------------------2005---#

direzioni={'I':(0, 0), 'A':(1,0), 'B':(-1, 0), 'D':(0, 1), 'S':(0, -1)}

# Costanti
P="P"
C="C"
A="A"
B="B"
D="D"
S="S"
I="I"

def coppiaint(s):
  """Trasforma la stringa s in una coppia di interi."""
  l=s.split(' ')
  return int(l[0]), int(l[1])

class Korrot(object):
  """Classe che implementa l'automa Korrot."""
  def __init__(self, fin, fout):
    """Inizializza le variabili di Korrot."""
# alcuni attributi sono letti dal file fin
    file_input=open(fin)
    self.righe, self.colonne = coppiaint(file_input.readline())
    self.k, self.poltrona = coppiaint(file_input.readline())
    self.ostacoli=[]
    for linea in file_input.readlines():
      if linea<>"\n": self.ostacoli.append(coppiaint(linea))
# apre in scrittura il file di output
    self.file_output=open(fout, "w")
# inizializza alcuni altri attributi
    self.kriga=1
    self.kcolonna=self.k
    self.direzione=A
    self.percorso=""

  def __str__(self):
    """Converte in stringa i dari letti dal file."""
    return """\
    coordinate: (%s; %s)
    direzione: %s
    dimensioni: %s righe e %s colonne
    poltrona: %s
    ostacoli: %s""" \
    % (self.kriga, self.kcolonna, self.direzione,
       self.righe, self.colonne, self.poltrona, self.ostacoli)
           
  def conquista(self):
    """Tenta la conquista della poltrona,
    termina se l'ha raggiunta o se  in confusione."""
    while self.direzione<>P and self.direzione<>C:
      self.muovi()
      self.percorso+=self.direzione+" "     # memorizza il percorso
    self.esito=self.direzione               # memorizza l'esito
    print self.percorso
    print self.esito
    self.file_output.write(self.percorso)
    self.file_output.write("\n"+self.direzione)

  def mosso(self, dir):
    """Se  possibile, segue un movimento nella direzione dir.
    Restituisce True se  stato possibile, False in caso contrario."""
    kriga=self.kriga+direzioni[dir][0]
    kcolonna=self.kcolonna+direzioni[dir][1]
    if not (kriga, kcolonna) in self.ostacoli:
      self.kriga=kriga
      self.kcolonna=kcolonna
      self.direzione=dir
      return True                       # mossa valida: effettuata
    else:
      return False                      # mossa non valida, non eseguita

  def muovi(self):
    """Implementa tutte le regole che comandano il movimento di Korrot."""
# Ha raggiunto la poltrona
    if self.kcolonna==self.poltrona and self.kriga==self.righe:
      self.direzione=P
      return
# Si sta muovendo verso l'Alto.
    if self.direzione==A:
      if self.kriga==self.righe:
        if self.poltrona<self.kcolonna:
          if self.mosso(S): return
        else:
          if self.mosso(D): return
      elif self.mosso(A): return
      elif self.kcolonna==self.colonne and self.mosso(S): return
      elif self.mosso(D): return
# Si sta muovendo verso Destra
    elif self.direzione==D:
      if self.mosso(A): return
      elif self.kcolonna<self.colonne and self.mosso(D): return
      elif self.kriga==self.righe and self.mosso(B): return
# Si sta muovendo verso Sinistra
    elif self.direzione==S:
      if self.kriga<self.righe and self.mosso(A): return
      elif self.kriga==self.righe and (self.mosso(S) or self.mosso(B)): return
      elif self.kriga==self.righe-1 and self.mosso(S): return
# Si sta muovendo verso il Basso
    elif self.direzione==B:
      if self.poltrona<self.kcolonna:
        if self.mosso(S): return
      else:
        if self.mosso(D): return
# Non  riuscito a muoversi quindi va in Confusione
    self.direzione=C

def prova(nfinput, nfoutput):
  """Stampa i dati letti dal file nfinput e la soluzione."""
  k=Korrot(nfinput, nfoutput)         # Crea un nuovo Korrot
  print k                             # Stampa i suoi dati
  k.conquista()                       # Lo lancia alla conquista di una poltrona

prova('korrot01i.dat', 'korrot01o.dat')
prova('korrot02i.dat', 'korrot02o.dat')
prova('korrot03i.dat', 'korrot03o.dat')
prova('korrot04i.dat', 'korrot04o.dat')
prova('korrot05i.dat', 'korrot05o.dat')
prova('korrot06i.dat', 'korrot06o.dat')
