#!/usr/bin/env python
# -*- coding: iso-8859-15 -*-
#-------------------------------python-----------------------codice.py--#
#                                                                       #
#             Olimpiadi dell'informatica: Codice segreto                #
#                                                                       #
#--Daniele Zambelli-----------licenza GPL------------------------2005---#

class CodDecod:
    
  def __init__(self):
    """Inizializza il cod-decodificatore."""
# dizionario di base
    self.cod={"a":"e","e":"i","i":"o","o":"u","u":"y","y":"a",
              "b":"c","c":"d","d":"f","f":"g","g":"h","h":"j","j":"k",
              "k":"l","l":"m","m":"n","n":"p","p":"q","q":"r","r":"s",
              "s":"t","t":"v","v":"w","w":"x","x":"z","z":"b",
              "0":"1","1":"2","2":"3","3":"4","4":"5",
              "5":"6","6":"7","7":"8","8":"9","9":"0"}
# aggiunge la codifica delle lettere maiuscole
    for k in self.cod.keys():
      self.cod[k.upper()]=self.cod[k].upper()
# inverte il dizionario per la decodifica
    self.dec={}
    for k in self.cod.keys():
      self.dec[self.cod[k]]=k

  def coddec(self, s, codice):
    """Codifica una stribga in base a codice."""
    key=codice.keys()           # legge le chiavi
    result=""
    for l in s:                 # per ogni carattere della stringa
      if l in key:              # se  codificato...
        result+=codice[l]       #   aggiunge al risultato il suo corrispondente
      else:                     # altrimenti
        result+=l               #   lo aggiunge al risultato senza modifiche
    return result               # restituisce il risultato

  def codifica(self, s):
    """Codifica una stringa."""
    return self.coddec(s, self.cod)

  def decodifica(self, s):
    """Decodifica una stringa."""
    return self.coddec(s, self.dec)

  def coddecfile(self, nfi, nfo, codice):
    """Codifica il file nfi in base a codice il risultato in nfo."""
    file_output=open(nfo, "w")  # apre il file di output
    for l in open(nfi):         # per ogni riga del file di input
      print l                   # la stampa
      s=self.coddec(l, codice)  # la codifica
      print s                   # stampa il risultato
      file_output.write(s)      # la scrive nel file di output

  def codfile(self, nfi, nfo):
    """Codifica il file nfi e scrive il risultato in nfo."""
    self.coddecfile(nfi, nfo, self.cod)

  def decodfile(self, nfi, nfo):
    """Decodifica il file nfi e scrive il risultato in nfo."""
    self.coddecfile(nfi, nfo, self.dec)

cd=CodDecod()
cd.codfile("testo01.txt", "cripto01.txt")
print "\n\n"
cd.decodfile("cripto01.txt", "ritesto01.txt")
